module MODEXP where

exM ::  Integer -> Integer -> Integer -> Integer
exM a b n = exM' a (toBin b) n 1

exM' ::  Integer -> [Integer] -> Integer -> Integer -> Integer
exM' _ [] _ d = d
exM' a (b_i:b_rest) n d 
    | b_i == 1  = exM' a b_rest n (mod ((mod (d*d) n)*a) n)
    | otherwise = exM' a b_rest n (mod (d*d) n)

toBin :: Integer -> [ Integer ]
toBin 0 = [ 0 ]
toBin n = toBin (quot n 2) ++ [rem n 2]
